/**
 * -----------------------------------------------------------------------------
 * file: estatPM.js
 * file version: 1.0.0
 * date: 2011-12-02
 *
 * Page Manager
 */

var themeColor={
      border:'#666666',
      background:'#222222'
    }


/**
 * estatPM class
 * used to manage the admin interface
 *
 * public functions :
 *  - changePage(pageName)
 */
$.EStatManagePages = function (fct, values)
{
  var $this = this,
      properties={
        url:'',
        urlExport:'',
        token:'',
        itemPerPage:50,
        currentPage:'Stats_by_period',
        initPhase:false,
        graph:{
            axis:{
                color:'#666666',
                ticksSize:{
                    small:1,
                    big:10
                  },
                minSpaceLast:5,
                frequency:{
                    small:2,
                    big:5
                  },
                value:{
                    rotateH:20,
                    rotateV:0,
                    fontName:'arial',
                    fontSize:8
                  }
              },
            colors:{
                normal:[
                    '#ffdd18',  //  0: yellow
                    '#b73561',  //  1: red purple
                    '#00a14b',  //  2: green
                    '#fe4819',  //  3: red-orange
                    '#21409a',  //  4: blue
                    '#f99d28',  //  5: yellow-orange
                    '#7f4098',  //  6: purple
                    '#8cc63f',  //  7: yellow-green
                    '#ed1c24',  //  8: red
                    '#07707d',  //  9: blue-green
                    '#f26522',  // 10: orange
                    '#584099'   // 11: blue-purple
                  ],
                light:[
                    '#ffe466',  //  0: yellow
                    '#c5667a',  //  1: red purple
                    '#6ab574',  //  2: green
                    '#f58256',  //  3: red-orange
                    '#5a64ac',  //  4: blue
                    '#fcbe75',  //  5: yellow-orange
                    '#996caf',  //  6: purple
                    '#a8d171',  //  7: yellow-green
                    '#f16045',  //  8: red
                    '#548490',  //  9: blue-green
                    '#f78f58',  // 10: orange
                    '#7968ae'   // 11: blue-purple
                  ],
                dark:[
                    '#bfa417',  //  0: yellow
                    '#872146',  //  1: red purple
                    '#057938',  //  2: green
                    '#b23016',  //  3: red-orange
                    '#142a75',  //  4: blue
                    '#b8761f',  //  5: yellow-orange
                    '#5f2974',  //  6: purple
                    '#66952d',  //  7: yellow-green
                    '#b11016',  //  8: red
                    '#05535d',  //  9: blue-green
                    '#b34b14',  // 10: orange
                    '#422a74'   // 11: blue-purple
                  ],
                gray:[
                    '#111111',  //  0:
                    '#222222',  //  1:
                    '#333333',  //  2:
                    '#444444',  //  3:
                    '#555555',  //  4:
                    '#666666',  //  5:
                    '#777777',  //  6:
                    '#888888',  //  7:
                    '#999999',  //  8:
                    '#AAAAAA',  //  9:
                    '#BBBBBB',  // 10:
                    '#CCCCCC',  // 11:
                    '#DDDDDD',  // 12:
                    '#EEEEEE'   // 13:
                  ]
              }
          },
        history:{
            graphAllPeriods:{
                axis:null,
                serieTotal:null,
                serieComputer:null,
                serieMobile:null,
                serieCrawler:null,
                serieOther:null
              },
            graphCurrentPeriod:{
                axis:null,
                serieTotal:null,
                serieComputer:null,
                serieMobile:null,
                serieCrawler:null,
                serieOther:null
              }
          },
        period:{
            graph:{
                axis:null,
                serieViewedAlbums:null,
                serieViewedImages:null,
                serieViewedPages:null,
                serieUniqueIP:null
              }
          },
        ip:{
            graphType:{
                axis:null,
                serie:null
              },
            graphCountry:{
                axis:null,
                serie:null
              }
          }
      }, // << properties={...}

    /**
     * -------------------------------------------------------------------------
     * set the properties values
     * -------------------------------------------------------------------------
     */
    setProperties = function (values)
      {
        if(values==null)
          values=$(window).data('EStatMPProperties');

        if(values==null) return(false);

        if(values.url)
          properties.url=values.url;

        if(values.urlExport)
          properties.urlExport=values.urlExport;

        if(values.token)
          properties.token=values.token;

        if(values.itemPerPage)
          properties.itemPerPage=values.itemPerPage;

        if(values.currentPage)
          properties.currentPage=values.currentPage;

        if(values.history)
          properties.history=values.history;

        if(values.period)
          properties.period=values.period;

        if(values.ip)
          properties.ip=values.ip;

        $(window).data('EStatMPProperties', properties);
        return(true);
      }, // << setProperties()



    /**
     * -------------------------------------------------------------------------
     *
     *                      INITIALIZATION FUNCTIONS
     *
     *
     * -------------------------------------------------------------------------
     */

    /**
     * -------------------------------------------------------------------------
     * this function initialize the page (jquery objects) and preload data page
     * -------------------------------------------------------------------------
     */
    init=function ()
      {
        properties.initPhase=true;

        initGlobalObjects();
        //initPageSynthesis();
        initPagePeriod();
        initPageIP();
        initPageCategory();
        initPageImage();
        initPageHistory();
        //initPageConfig();
        //initPageTools();

        properties.initPhase=false;
        changePage('Stats_by_period');
      },

    /**
     * -------------------------------------------------------------------------
     * initialise objects common to all pages
     * -------------------------------------------------------------------------
     */
    initGlobalObjects = function()
      {
        $('#iFilterCatId').categorySelector(
          {
            listMaxWidth:600,
            listMaxHeight:350,
            displayStatus:true,
            displayPath:true,
            multiple:true,
            levelIndent:20,
            userMode:'public',
            galleryRoot:false,
            load: function (event)
                    {
                      $(this).categorySelector('expand', ':all+0');
                      //$(this).categorySelector('value', ':first');
                    },
            change: function (event)
                    {
                      loadPage();
                    }
          }
        );

        $('#iFilterPeriodId').inputTreeList(
          {
            listMaxWidth:600,
            listMaxHeight:350,
            levelIndent:15,
            iconWidthEC:10,
            displayPath:true,
            postUrl:properties.url,
            displayNfo:false,
            multiple:false,
            postData:{
              ajaxfct:"admin.stat.periodTreeList",
              token:properties.token
            },
            load: function (event)
                    {
                      $(this).inputTreeList('collapse', ':all+0');
                      $(this).inputTreeList('value', ':first');
                    },
            change: function (event)
                    {
                      loadPage();
                    }
          }
        );
      }, // << initGlobalObjects()

    initPageSynthesis = function()
      {

      }, // << initPageSynthesis()

    /**
     * -------------------------------------------------------------------------
     * initialise objects for period page
     * -------------------------------------------------------------------------
     */
    initPagePeriod = function()
      {
        // create history dynamic table
        $('#iPeriodTable').dynamicTable(
          {
            columns:
              [
                {
                  id:'period',
                  title:translateString.period,
                  sortable:'no',
                  width:'20%'
                },
                {
                  id:'viewedPages',
                  title:translateString.viewedPages,
                  sortable:'no',
                  width:'20%'
                },

                {
                  id:'viewedAlbums',
                  title:translateString.viewedAlbums,
                  sortable:'no',
                  width:'20%'
                },

                {
                  id:'viewedImages',
                  title:translateString.viewedImages,
                  sortable:'no',
                  width:'20%'
                },

                {
                  id:'uniqueIP',
                  title:translateString.uniqueIP,
                  sortable:'no'
                }
              ],
            showTotalRow:'visible',
            showSaveButton:false,
            autoLoad:false,
            postUrl:properties.url,
            postData:
              {
                ajaxfct:"admin.stat.period",
                token:properties.token,
                period:''
              },
            minHeight:350,
            maxHeight:350,
            nbItemsPage:properties.itemPerPage,
            footerString:
              {
                singular:'',
                plural:''
              },
/*
            pageChanged: function (event, value)
              {
              },
*/
            contentLoading: function (event, value)
              {
                $('#iPeriodTable').dynamicTable('click', 'clear');
              },
            contentLoaded: function (event, value)
              {
                switch($('#iPeriodPath').inputPath('level'))
                {
                  case 1:
                  case 2:
                    $('#iPeriodTable').dynamicTable('click', clickOnPeriodTable);
                    break;
                  case 3:
                    $('#iPeriodTable').dynamicTable('click', 'clear');
                    break;
                }

              },
            click: clickOnPeriodTable
          }
        );


        // create graph - stat for all period
        properties.period.graph.axis=new CDAxis(
          {
            mode:'XY',
            display:{
              color:properties.graph.axis.color,
              visible:
                {
                  XY:
                  {
                    H:true,
                    V:true
                  }
                }
            },
            XY:{
              ticks:{
                  H:{
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    frequency:{
                      small:1, //properties.graph.axis.frequency.small,
                      big:1 //properties.graph.axis.frequency.big
                    },
                    value:{
                      rotate:properties.graph.axis.value.rotateH,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    },
                    offset0:true
                  },
                  V:{
                    unit:'',
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    steps:10000,
                    frequency:{
                      small:250,
                      big:1000
                    },
                    value:{
                      rotate:properties.graph.axis.value.rotateV,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    }
                  }
                }
              },
            values:{H:[]}
          }
        );

        properties.period.graph.serieViewedPages=new CDSerie(
          {
            name:'viewedPages',
            order:10,
            values:[],
            options:new CDSerieOptionsBar(
              {
                backgroundColor:properties.graph.colors.gray[3],
                borderColor:properties.graph.colors.gray[7],
                borderWidth:0,
                width:1,
                offset:0
              }
            )
          }
        );

        properties.period.graph.serieViewedAlbums=new CDSerie(
          {
            name:'viewedAlbums',
            order:2,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[0],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.period.graph.serieViewedImages=new CDSerie(
          {
            name:'viewedImages',
            order:3,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[1],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.period.graph.serieUniqueIP=new CDSerie(
          {
            name:'uniqueIP',
            order:4,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[2],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.period.graph.axis.serieAdd(properties.period.graph.serieViewedAlbums);
        properties.period.graph.axis.serieAdd(properties.period.graph.serieViewedImages);
        properties.period.graph.axis.serieAdd(properties.period.graph.serieViewedPages);
        properties.period.graph.axis.serieAdd(properties.period.graph.serieUniqueIP);


        $('#iPeriodGraph').drawingGraph(
          {
            display:
              {
                width:450,
                height:150
              },
            cursor:
              {
                verticalType:'line'
              },
            margins:new CDMargins({top:5,bottom:45, left:50, right:1}),
            legend:new CDLegend({
                          width:0,
                          visible:false,
                          position:'right',  // left or right
                          backgroundColor:themeColor.background,
                          borderColor:themeColor.border,
                          borderWidth:0,
                          fontName:'arial',
                          fontSize:10
                        }),
            axis:{front:properties.period.graph.axis, back:null},
            events:{
              mouseEnter:function (event)
                          {
                            var geometry={
                                  x:0,
                                  y:0,
                                  w:250,
                                  h:75
                                };

                            geometry.x=$('#iPeriodGraph').offset().left+($('#iPeriodGraph').width()-geometry.w)/2;
                            geometry.y=$('#iPeriodGraph').offset().top-geometry.h-10;
                            displayPopupInfo(true, geometry, getPeriodPopupContent());
                          },
              mouseLeave:function (event)
                          {
                            displayPopupInfo(false);
                          },
              mousePositionChange:function (event, data)
                          {
                            var list=['viewedAlbums', 'viewedImages', 'uniqueIP', 'viewedPages'];
                            for(i=0;i<list.length;i++)
                            {
                              $('#iPI_'+list[i]).html(data.values[i].value);
                            }
                          }
            }
          }
        );

        $('#iPeriodPath')
          .inputPath(
            {
              separator:'&gt;',
              autoSetLevel:true,
              click: function (event, value)
                {
                   loadPageStatByPeriod();
                }
            }
          )
          .inputPath('push', {id:'allYear', label:translateString.allYear});

      }, // << initPagePeriod()



    /**
     * -------------------------------------------------------------------------
     * initialise objects for IP page
     * -------------------------------------------------------------------------
     */
    initPageIP = function()
      {
        // create IP dynamic table
        $('#iIPTable').dynamicTable(
          {
            columns:
              [
                {
                  id:'IPadress',
                  title:translateString.ipAdress,
                  sortable:'asc',
                  filter:
                    {
                      title:translateString.ipAdress,
                      dataType:'string',
                      data:{
                          regexp:'\d{1,3}(?:\.\d{1,3}){0,3}'
                        },
                      defaultOperator:'like',
                      filterOperators:['like', 'not like', 'between', 'not between']
                    },
                  group:true,
                  width:'100px'
                },

                {
                  id:'country',
                  title:translateString.filter.country,
                  sortable:'asc',
                  group:true,
                  filter:
                    {
                      title:translateString.filter.country,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=country&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    }
                },

                {
                  id:'uaType',
                  title:translateString.type,
                  filter:
                    {
                      title:translateString.filter.type,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaType&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  group:true,
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'nbVisits',
                  title:translateString.visits,
                  sortable:'asc',
                  width:'90px'
                }

              ],
            showTotalRow:'visible',
            showSaveButton:true,
            autoLoad:false,
            postUrl:properties.url,
            postData:
              {
                ajaxfct:"admin.stat.ip",
                token:properties.token,
                period:''
              },
            minHeight:350,
            maxHeight:350,
            nbItemsPage:properties.itemPerPage,
            sortBoxTitle:translateString.sortBy,
            footerString:
              {
                singular:translateString.item_nb,
                plural:translateString.items_nb,
                waitForDownload:translateString.waitForDownload
              },
            dialogsButtons:{
                ok:translateString.ok,
                cancel:translateString.cancel,
                erase:translateString.eraseFilter
              },
            saveButtonClick: function (event, data)
              {
                $.dialogExport(
                  {
                    title:translateString.dataExport,
                    buttons:
                      {
                        ok:translateString.ok,
                        cancel:translateString.cancel
                      },
                    name:'ipAdress',
                    format:'csv',
                    compression:'gz',
                    formatList:
                      [
                        {id:'csv', text:translateString.fileFormatCSV, infos:'(.csv)'},
                        {id:'ods', text:translateString.fileFormatODS, infos:'(.ods)'},
                        {id:'sqlite', text:translateString.fileFormatSQLite, infos:'(.db)'}
                      ],
                    compressionList:
                      [
                        {id:'none', text:translateString.fileCompressionNone, infos:''},
                        {id:'zip', text:translateString.fileCompressionZIP, infos:'(.zip)'},
                        {id:'gz', text:translateString.fileCompressionGZ, infos:'(.gz)'},
                        {id:'bz2', text:translateString.fileCompressionBZ2, infos:'(.bz2)'}
                      ],
                    validExport: function (event, values)
                      {
                       $('#iIPTable').dynamicTable('waitForDownload', true);
                        $.ajax(
                          {
                            type: "POST",
                            url: properties.urlExport,
                            data:
                              {
                                ajaxfct:'admin.export.ip',
                                name:values.name,
                                format:values.format,
                                compression:values.compression,
                                token:properties.token,
                                period:$('#iFilterPeriodId').inputTreeList('value'),
                                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')},
                                sort:data.sort,
                                filter:data.filter,
                                group:data.group
                              },
                            async: true,
                            success: function(msg)
                              {
                                $('#iIPTable').dynamicTable('waitForDownload', false);
                                if(msg.substr(0,3)=='OK:')
                                {
                                  $.download(msg.substr(3));
                                }
                                else
                                {
                                  alert(translateString.downloadError);
                                }
                              },
                            error: function(msg)
                              {
                                $('#iIPTable').dynamicTable('waitForDownload', false);
                              }
                          }
                        );
                      }
                  }
                );
              },
              /*
            pageChanged: function (event, value)
              {
              },
            contentLoading: function (event, value)
              {
              },
            contentLoaded: function (event, value)
              {
              },
            click: function (event, value)
              {
              }
*/
          }
        );


        // create graph - stat for type of browser
        properties.ip.graphType.axis=new CDAxis(
          {
            mode:'pie',
            display:{visible:{pie:false}}
          }
        );
        properties.ip.graphType.serie=new CDSerie(
          {
            name:translateString.type,
            order:1,
            values:[],
            valuesLabels:[],
            options:new CDSerieOptionsPie(
              {
                outerRadius:85,
                innerRadius:20,
                offset:0,
                borderWidth:1,
                backgroundColors:properties.graph.colors.light
              }
            )
          }
        );
        properties.ip.graphType.axis.serieAdd(properties.ip.graphType.serie);

        $('#iIPGraphType').drawingGraph(
          {
            display:
              {
                width:225,
                height:150
              },
            margins:new CDMargins({top:0,bottom:0, left:0, right:0}),
            legend:new CDLegend({
                          width:20,
                          visible:true,
                          position:'left',  // left or right
                          backgroundColor:themeColor.background,
                          borderColor:themeColor.border,
                          borderWidth:0,
                          fontName:'arial',
                          fontSize:10
                        }),
            axis:{front:properties.ip.graphType.axis, back:null}
/*
            events:{
              mouseEnter:function (event)
                          {
                          },
              mouseLeave:function (event)
                          {
                          },
              mousePositionChange:function (event, data)
                          {
                          }
            }
*/
          }
        );


        // create graph - stat for countries
        properties.ip.graphCountry.axis=new CDAxis(
          {
            mode:'pie',
            display:{visible:{pie:false}}
          }
        );
        properties.ip.graphCountry.serie=new CDSerie(
          {
            name:translateString.country,
            order:1,
            values:[],
            valuesLabels:[],
            options:new CDSerieOptionsPie(
              {
                outerRadius:85,
                innerRadius:20,
                offset:0,
                borderWidth:1,
                backgroundColors:properties.graph.colors.light
              }
            )
          }
        );
        properties.ip.graphCountry.axis.serieAdd(properties.ip.graphCountry.serie);

        $('#iIPGraphCountry').drawingGraph(
          {
            display:
              {
                width:225,
                height:150
              },
            margins:new CDMargins({top:0,bottom:0, left:0, right:0}),
            legend:new CDLegend({
                          width:20,
                          visible:true,
                          position:'left',  // left or right
                          backgroundColor:themeColor.background,
                          borderColor:themeColor.border,
                          borderWidth:0,
                          fontName:'arial',
                          fontSize:10
                        }),
            axis:{front:properties.ip.graphCountry.axis, back:null}
/*
            events:{
              mouseEnter:function (event)
                          {
                          },
              mouseLeave:function (event)
                          {
                          },
              mousePositionChange:function (event, data)
                          {
                          }
            }
*/
          }
        );

      }, // << initPageIP()

    initPageCategory = function()
      {
        // create albums/categories dynamic table
        $('#iCategoryTable').dynamicTable(
          {
            columns:
              [
                {
                  id:'catId',
                  title:translateString.album,
                  sortable:'asc'
                },

                {
                  id:'uaType',
                  title:translateString.type,
                  filter:
                    {
                      title:translateString.filter.type,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaType&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  group:true,
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'nbVisits',
                  title:translateString.visits,
                  sortable:'asc',
                  width:'125px'
                }
              ],
            showTotalRow:'visible',
            showSaveButton:true,
            autoLoad:false,
            postUrl:properties.url,
            postData:
              {
                ajaxfct:"admin.stat.category",
                token:properties.token,
                period:''
              },
            minHeight:350,
            maxHeight:350,
            nbItemsPage:properties.itemPerPage,
            sortBoxTitle:translateString.sortBy,
            footerString:
              {
                singular:translateString.item_nb,
                plural:translateString.items_nb,
                waitForDownload:translateString.waitForDownload
              },
            dialogsButtons:{
                ok:translateString.ok,
                cancel:translateString.cancel,
                erase:translateString.eraseFilter
              },
/*
            pageChanged: function (event, value)
              {
              },
            contentLoaded: function (event, value)
              {
              },
            click: function (event, value)
              {
              },
*/
            saveButtonClick: function (event, data)
              {
                $.dialogExport(
                  {
                    title:translateString.dataExport,
                    buttons:
                      {
                        ok:translateString.ok,
                        cancel:translateString.cancel
                      },
                    name:'album',
                    format:'csv',
                    compression:'gz',
                    formatList:
                      [
                        {id:'csv', text:translateString.fileFormatCSV, infos:'(.csv)'},
                        {id:'ods', text:translateString.fileFormatODS, infos:'(.ods)'},
                        {id:'sqlite', text:translateString.fileFormatSQLite, infos:'(.db)'}
                      ],
                    compressionList:
                      [
                        {id:'none', text:translateString.fileCompressionNone, infos:''},
                        {id:'zip', text:translateString.fileCompressionZIP, infos:'(.zip)'},
                        {id:'gz', text:translateString.fileCompressionGZ, infos:'(.gz)'},
                        {id:'bz2', text:translateString.fileCompressionBZ2, infos:'(.bz2)'}
                      ],
                    validExport: function (event, values)
                      {
                        $('#iCategoryTable').dynamicTable('waitForDownload', true);
                        $.ajax(
                          {
                            type: "POST",
                            url: properties.urlExport,
                            data:
                              {
                                ajaxfct:'admin.export.category',
                                name:values.name,
                                format:values.format,
                                compression:values.compression,
                                token:properties.token,
                                period:$('#iFilterPeriodId').inputTreeList('value'),
                                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')},
                                sort:data.sort,
                                filter:data.filter,
                                group:data.group
                              },
                            async: true,
                            success: function(msg)
                              {
                                $('#iCategoryTable').dynamicTable('waitForDownload', false);
                                if(msg.substr(0,3)=='OK:')
                                {
                                  $.download(msg.substr(3));
                                }
                                else
                                {
                                  alert(translateString.downloadError);
                                }
                              },
                            error: function(msg)
                              {
                                $('#iCategoryTable').dynamicTable('waitForDownload', false);
                              }
                          }
                        );
                      }
                  }
                );
              },
            contentLoading: function (event, value)
              {
                $(this).find('tr[oid]').unbind('mouseenter mouseleave');
              },
            contentDisplayed: function (event, value)
              {
                for(var i=0;i<value.rows.length;i++)
                {
                  if(value.rows[i][3]!='')
                  {
                    $(this).find('tr[oid='+i+']')
                      .bind('mouseenter', {v:value.rows[i][3]}, function (e)
                                {
                                  displayPopupThumb(true, {x:e.pageX, y:$(this).offset().top}, e.data.v);
                                }
                            )
                      .bind('mouseleave', function (e)
                                {
                                  displayPopupThumb(false);
                                }
                            );
                  }
                }
              }
          }
        );
      }, // << initPageCategory()

    initPageImage = function()
      {
        // create albums/categories dynamic table
        $('#iImageTable').dynamicTable(
          {
            columns:
              [
                {
                  id:'imageId',
                  title:translateString.image,
                  sortable:'asc'
                },

                {
                  id:'uaType',
                  title:translateString.type,
                  filter:
                    {
                      title:translateString.filter.type,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaType&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  group:true,
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'nbVisits',
                  title:translateString.visits,
                  sortable:'asc',
                  width:'125px'
                }
              ],
            showTotalRow:'visible',
            showSaveButton:true,
            autoLoad:false,
            postUrl:properties.url,
            postData:
              {
                ajaxfct:"admin.stat.image",
                token:properties.token,
                period:''
              },
            minHeight:350,
            maxHeight:350,
            nbItemsPage:properties.itemPerPage,
            sortBoxTitle:translateString.sortBy,
            footerString:
              {
                singular:translateString.item_nb,
                plural:translateString.items_nb,
                waitForDownload:translateString.waitForDownload
              },
            dialogsButtons:{
                ok:translateString.ok,
                cancel:translateString.cancel,
                erase:translateString.eraseFilter
              },
/*
            pageChanged: function (event, value)
              {
              },
            contentLoaded: function (event, value)
              {
              },
            click: function (event, value)
              {
              }
*/
            saveButtonClick: function (event, data)
              {
                $.dialogExport(
                  {
                    title:translateString.dataExport,
                    buttons:
                      {
                        ok:translateString.ok,
                        cancel:translateString.cancel
                      },
                    name:'images',
                    format:'csv',
                    compression:'gz',
                    formatList:
                      [
                        {id:'csv', text:translateString.fileFormatCSV, infos:'(.csv)'},
                        {id:'ods', text:translateString.fileFormatODS, infos:'(.ods)'},
                        {id:'sqlite', text:translateString.fileFormatSQLite, infos:'(.db)'}
                      ],
                    compressionList:
                      [
                        {id:'none', text:translateString.fileCompressionNone, infos:''},
                        {id:'zip', text:translateString.fileCompressionZIP, infos:'(.zip)'},
                        {id:'gz', text:translateString.fileCompressionGZ, infos:'(.gz)'},
                        {id:'bz2', text:translateString.fileCompressionBZ2, infos:'(.bz2)'}
                      ],
                    validExport: function (event, values)
                      {
                        $('#iImageTable').dynamicTable('waitForDownload', true);
                        $.ajax(
                          {
                            type: "POST",
                            url: properties.urlExport,
                            data:
                              {
                                ajaxfct:'admin.export.image',
                                name:values.name,
                                format:values.format,
                                compression:values.compression,
                                token:properties.token,
                                period:$('#iFilterPeriodId').inputTreeList('value'),
                                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')},
                                sort:data.sort,
                                filter:data.filter,
                                group:data.group
                              },
                            async: true,
                            success: function(msg)
                              {
                                $('#iImageTable').dynamicTable('waitForDownload', false);
                                if(msg.substr(0,3)=='OK:')
                                {
                                  $.download(msg.substr(3));
                                }
                                else
                                {
                                  alert(translateString.downloadError);
                                }
                              },
                            error: function(msg)
                              {
                                $('#iImageTable').dynamicTable('waitForDownload', false);
                              }
                          }
                        );
                      }
                  }
                );
              },
            contentLoading: function (event, value)
              {
                $(this).find('tr[oid]').unbind('mouseenter mouseleave');
              },
            contentDisplayed: function (event, value)
              {
                for(var i=0;i<value.rows.length;i++)
                {
                  if(value.rows[i][3]!='')
                  {
                    $(this).find('tr[oid='+i+']')
                      .bind('mouseenter', {v:value.rows[i][3]}, function (e)
                                {
                                  displayPopupThumb(true, {x:e.pageX, y:$(this).offset().top}, e.data.v);
                                }
                            )
                      .bind('mouseleave', function (e)
                                {
                                  displayPopupThumb(false);
                                }
                            );
                  }
                }
              }
          }
        );
      }, // << initPageImage()


    /**
     * -------------------------------------------------------------------------
     * initialise objects for history page
     * -------------------------------------------------------------------------
     */
    initPageHistory = function()
      {
        // create history dynamic table
        $('#iHistoryTable').dynamicTable(
          {
            columns:
              [
                {
                  id:'date',
                  title:translateString.dateTime,
                  filter:
                    {
                      title:translateString.filter.dateTime,
                      dataType:'datetime',
                      data:{
                          timeFormat:'hh:mm'
                        },
                      defaultOperator:'between',
                      filterOperators:['>', '<', '>=', '<=', '=', '!=', 'between', 'not between']
                    },
                  sortable:'asc',
                  width:'125px'
                },
                {
                  id:'IPadress',
                  title:translateString.ip_user,
                  filter:
                    {
                      title:translateString.filter.ipAdress,
                      dataType:'string',
                      data:{
                          regexp:'\d{1,3}(?:\.\d{1,3}){0,3}'
                        },
                      defaultOperator:'like',
                      filterOperators:['like', 'not like', 'between', 'not between']
                    },
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'catId',
                  title:translateString.album,
                  sortable:'no',
                  width:'225px'
                },

                {
                  id:'imageId',
                  title:translateString.image,
                  sortable:'no',
                  width:'200px'
                },

                {
                  id:'tags',
                  title:translateString.tags,
                  sortable:'no'
                },

                {
                  id:'section',
                  title:translateString.section,
                  filter:
                    {
                      title:translateString.filter.section,
                      dataType:'dataset',
                      data:{
                          serverUrl:''
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  sortable:'asc',
                  width:'100px'
                },

                {
                  id:'uaBrowser',
                  title:translateString.browser,
                  filter:
                    {
                      title:translateString.filter.browser,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaBrowser&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  sortable:'asc',
                  width:'165px'
                },

                {
                  id:'uaEngine',
                  title:translateString.engine,
                  filter:
                    {
                      title:translateString.filter.engine,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaEngine&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'uaOS',
                  title:translateString.os,
                  filter:
                    {
                      title:translateString.filter.os,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaOS&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  sortable:'asc',
                  width:'125px'
                },

                {
                  id:'uaType',
                  title:translateString.type,
                  filter:
                    {
                      title:translateString.filter.type,
                      dataType:'dataset-url',
                      data:{
                          serverUrl:properties.url+'?ajaxfct=admin.fct.validValues&domain=uaType&token='+properties.token
                        },
                      defaultOperator:'in',
                      filterOperators:['in']
                    },
                  sortable:'asc',
                  width:'125px'
                }
              ],
            showSaveButton:true,
            autoLoad:false,
            postUrl:properties.url,
            postData:
              {
                ajaxfct:"admin.stat.history",
                token:properties.token,
                period:''
              },
            minHeight:150,
            maxHeight:350,
            nbItemsPage:properties.itemPerPage,
            sortBoxTitle:translateString.sortBy,
            footerString:
              {
                singular:translateString.item_nb,
                plural:translateString.items_nb,
                waitForDownload:translateString.waitForDownload
              },
            dialogsButtons:{
                ok:translateString.ok,
                cancel:translateString.cancel,
                erase:translateString.eraseFilter
              },
/*
            pageChanged: function (event, value)
              {
              },
            contentLoading: function (event, value)
              {
              },
*/
            saveButtonClick: function (event, data)
              {
                $.dialogExport(
                  {
                    title:translateString.dataExport,
                    buttons:
                      {
                        ok:translateString.ok,
                        cancel:translateString.cancel
                      },
                    name:'history',
                    format:'csv',
                    compression:'gz',
                    formatList:
                      [
                        {id:'csv', text:translateString.fileFormatCSV, infos:'(.csv)'},
                        {id:'ods', text:translateString.fileFormatODS, infos:'(.ods)'},
                        {id:'sqlite', text:translateString.fileFormatSQLite, infos:'(.db)'}
                      ],
                    compressionList:
                      [
                        {id:'none', text:translateString.fileCompressionNone, infos:''},
                        {id:'zip', text:translateString.fileCompressionZIP, infos:'(.zip)'},
                        {id:'gz', text:translateString.fileCompressionGZ, infos:'(.gz)'},
                        {id:'bz2', text:translateString.fileCompressionBZ2, infos:'(.bz2)'}
                      ],
                    validExport: function (event, values)
                      {
                        $('#iHistoryTable').dynamicTable('waitForDownload', true);
                        $.ajax(
                          {
                            type: "POST",
                            url: properties.urlExport,
                            data:
                              {
                                ajaxfct:'admin.export.history',
                                name:values.name,
                                format:values.format,
                                compression:values.compression,
                                token:properties.token,
                                period:$('#iHistoryFilterPeriod').inputList('value'),
                                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')},
                                sort:data.sort,
                                filter:data.filter,
                                group:data.group
                              },
                            async: true,
                            success: function(msg)
                              {
                                $('#iHistoryTable').dynamicTable('waitForDownload', false);
                                if(msg.substr(0,3)=='OK:')
                                {
                                  $.download(msg.substr(3));
                                }
                                else
                                {
                                  alert(translateString.downloadError);
                                }
                              },
                            error: function(msg)
                              {
                                $('#iHistoryTable').dynamicTable('waitForDownload', false);
                              }
                          }
                        );
                      }
                  }
                );
              },
            contentLoading: function (event, value)
              {
                $(this).find('tr[oid]').unbind('mouseenter mouseleave');
              },
            contentDisplayed: function (event, value)
              {
                for(var i=0;i<value.rows.length;i++)
                {
                  if(value.rows[i][11]!='')
                  {
                    $(this).find('tr[oid='+i+']')
                      .bind('mouseenter', {v:value.rows[i][11]}, function (e)
                                {
                                  displayPopupThumb(true, {x:e.pageX, y:$(this).offset().top}, e.data.v);
                                }
                            )
                      .bind('mouseleave', function (e)
                                {
                                  displayPopupThumb(false);
                                }
                            );
                  }
                }
              }
/*
            click: function (event)
              {
                var oId=$(this).attr('oId'),
                    data=$('#table1').dynamicTable('loadedData', oId);
              }
*/
          }
        );


        // create graph - stat for all period
        properties.history.graphAllPeriods.axis=new CDAxis(
          {
            mode:'XY',
            display:{
              color:properties.graph.axis.color,
              visible:
                {
                  XY:
                  {
                    H:true,
                    V:true
                  }
                }
            },
            XY:{
              ticks:{
                  H:{
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    frequency:{
                      small:1, //properties.graph.axis.frequency.small,
                      big:1 //properties.graph.axis.frequency.big
                    },
                    value:{
                      rotate:properties.graph.axis.value.rotateH,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    },
                    offset0:true
                  },
                  V:{
                    unit:'',
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    steps:10000,
                    frequency:{
                      small:250,
                      big:1000
                    },
                    value:{
                      rotate:properties.graph.axis.value.rotateV,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    }
                  }
                }
              },
            values:{H:[]}
          }
        );

        properties.history.graphAllPeriods.serieTotal=new CDSerie(
          {
            name:'total',
            order:10,
            values:[],
            options:new CDSerieOptionsBar(
              {
                backgroundColor:properties.graph.colors.gray[3],
                borderColor:properties.graph.colors.gray[7],
                borderWidth:0,
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphAllPeriods.serieComputer=new CDSerie(
          {
            name:'computer',
            order:1,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[0],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphAllPeriods.serieMobile=new CDSerie(
          {
            name:'mobile',
            order:2,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[1],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphAllPeriods.serieCrawler=new CDSerie(
          {
            name:'crawler',
            order:3,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[2],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphAllPeriods.serieOther=new CDSerie(
          {
            name:'other',
            order:4,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[3],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphAllPeriods.axis.serieAdd(properties.history.graphAllPeriods.serieTotal);
        properties.history.graphAllPeriods.axis.serieAdd(properties.history.graphAllPeriods.serieComputer);
        properties.history.graphAllPeriods.axis.serieAdd(properties.history.graphAllPeriods.serieMobile);
        properties.history.graphAllPeriods.axis.serieAdd(properties.history.graphAllPeriods.serieCrawler);
        properties.history.graphAllPeriods.axis.serieAdd(properties.history.graphAllPeriods.serieOther);


        $('#iHistoryGraphAll').drawingGraph(
          {
            display:
              {
                width:450,
                height:150
              },
            cursor:
              {
                verticalType:'line'
              },
            margins:new CDMargins({top:5,bottom:45, left:50, right:1}),
            legend:new CDLegend({
                          width:0,
                          visible:false,
                          position:'right',  // left or right
                          backgroundColor:themeColor.background,
                          borderColor:themeColor.border,
                          borderWidth:0,
                          fontName:'arial',
                          fontSize:10
                        }),
            axis:{front:properties.history.graphAllPeriods.axis, back:null},
            events:{
              mouseEnter:function (event)
                          {
                            var geometry={
                                  x:0,
                                  y:0,
                                  w:250,
                                  h:90
                                };

                            geometry.x=$('#iHistoryGraphAll').offset().left+($('#iHistoryGraphAll').width()-geometry.w)/2;
                            geometry.y=$('#iHistoryGraphAll').offset().top+$('#iHistoryGraphAll').height();
                            displayPopupInfo(true, geometry, getHistoryPopupContent());
                          },
              mouseLeave:function (event)
                          {
                            displayPopupInfo(false);
                          },
              mousePositionChange:function (event, data)
                          {
                            var list=['computer', 'mobile', 'crawler', 'other', 'total'];
                            for(i=0;i<list.length;i++)
                            {
                              $('#iPI_'+list[i]).html(data.values[i].value);
                            }
                          }
            }
          }
        );


        // create graph - stat for the current period
        properties.history.graphCurrentPeriod.axis=new CDAxis(
          {
            mode:'XY',
            display:{
              color:properties.graph.axis.color,
              visible:
                {
                  XY:
                  {
                    H:true,
                    V:true
                  }
                }
            },
            XY:{
              ticks:{
                  H:{
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    frequency:{
                      small:1, //properties.graph.axis.frequency.small,
                      big:1 //properties.graph.axis.frequency.big
                    },
                    value:{
                      rotate:60, //properties.graph.axis.value.rotateH,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    },
                    offset0:true
                  },
                  V:{
                    unit:'',
                    size:{
                      small:properties.graph.axis.ticksSize.small,
                      big:properties.graph.axis.ticksSize.big
                    },
                    visible:{
                      small:true,
                      big:true
                    },
                    minSpaceLast:properties.graph.axis.minSpaceLast,
                    steps:10000,
                    frequency:{
                      small:250,
                      big:1000
                    },
                    value:{
                      rotate:properties.graph.axis.value.rotateV,
                      visible:true,
                      fontName:properties.graph.axis.value.fontName,
                      fontSize:properties.graph.axis.value.fontSize
                    }
                  }
                }
              },
            values:{H:[]}
          }
        );

        properties.history.graphCurrentPeriod.serieTotal=new CDSerie(
          {
            name:'total',
            order:10,
            values:[],
            options:new CDSerieOptionsBar(
              {
                backgroundColor:properties.graph.colors.gray[3],
                borderColor:properties.graph.colors.gray[7],
                borderWidth:0,
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphCurrentPeriod.serieComputer=new CDSerie(
          {
            name:'computer',
            order:1,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[0],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphCurrentPeriod.serieMobile=new CDSerie(
          {
            name:'mobile',
            order:2,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[1],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphCurrentPeriod.serieCrawler=new CDSerie(
          {
            name:'crawler',
            order:3,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[2],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphCurrentPeriod.serieOther=new CDSerie(
          {
            name:'other',
            order:4,
            values:[],
            options:new CDSerieOptionsLine(
              {
                color:properties.graph.colors.normal[3],
                width:1,
                offset:0
              }
            )
          }
        );

        properties.history.graphCurrentPeriod.axis.serieAdd(properties.history.graphCurrentPeriod.serieTotal);
        properties.history.graphCurrentPeriod.axis.serieAdd(properties.history.graphCurrentPeriod.serieComputer);
        properties.history.graphCurrentPeriod.axis.serieAdd(properties.history.graphCurrentPeriod.serieMobile);
        properties.history.graphCurrentPeriod.axis.serieAdd(properties.history.graphCurrentPeriod.serieCrawler);
        properties.history.graphCurrentPeriod.axis.serieAdd(properties.history.graphCurrentPeriod.serieOther);


        $('#iHistoryGraphCurrent').drawingGraph(
          {
            display:
              {
                width:500,
                height:150
              },
            cursor:
              {
                verticalType:'line'
              },
            margins:new CDMargins({top:5,bottom:45, left:50, right:1}),
            legend:new CDLegend({
                          width:0,
                          visible:true,
                          position:'right',  // left or right
                          backgroundColor:themeColor.background,
                          borderColor:themeColor.border,
                          borderWidth:0,
                          fontName:'arial',
                          fontSize:10
                        }),
            axis:{front:properties.history.graphCurrentPeriod.axis, back:null},
            events:{
              mouseEnter:function (event)
                          {
                            var geometry={
                                  x:0,
                                  y:0,
                                  w:250,
                                  h:90
                                };

                            geometry.x=$('#iHistoryGraphCurrent').offset().left+($('#iHistoryGraphCurrent').width()-geometry.w)/2;
                            geometry.y=$('#iHistoryGraphCurrent').offset().top+$('#iHistoryGraphCurrent').height();
                            displayPopupInfo(true, geometry, getHistoryPopupContent());
                          },
              mouseLeave:function (event)
                          {
                            displayPopupInfo(false);
                          },
              mousePositionChange:function (event, data)
                          {
                            var list=['computer', 'mobile', 'crawler', 'other', 'total'];
                            for(i=0;i<list.length;i++)
                            {
                              $('#iPI_'+list[i]).html(data.values[i].value);
                            }
                          }
            }
          }
        );


        // load period list
        $('#iHistoryFilterPeriod').inputList(
          {
            serverUrl:properties.url,
            postData:
              {
                ajaxfct:'admin.stat.history.periodList',
                token:properties.token
              },
            listMaxWidth:650,
            listMaxHeight:300,
            multiple:false,
            colsWidth:[180],
            colsCss:['cPFilterDate','cPFilterNB'],
            colsDisplayed:[0,1],
            //popup: function (event, value) { },
            change: function (event, value)
                    {
                      loadPageHistory(value);
                    },
            load: function (event, value)
                    {
                      $('#iHistoryFilterPeriod').inputList('value', ':last');
                      loadPageHistory(value);
                    }
          }
        );
      }, // << initPageHistory()


    initPageConfig = function()
      {

      }, // << initPageConfig()

    initPageTools = function()
      {

      }, // << initPageTools()

    /**
     * -------------------------------------------------------------------------
     *
     *                      PAGE MANAGMENT FUNCTIONS
     *
     *
     * -------------------------------------------------------------------------
     */


    /**
     * -------------------------------------------------------------------------
     * this function is used to change a page : switch the page, call the data...
     *
     * @param String pageName : the name of page to display
     * @return Boolean : true if ok, otherwise false
     * -------------------------------------------------------------------------
     */
    changePage = function(pageName)
      {
        $('.cTabContent').css('display', 'none');
        $('#iTab'+pageName).css('display', 'inline-block');
        switch(pageName)
        {
          case 'Stats_by_period':
            $('#iTabFilter').css('display', 'block');
            $('#iFilterCategory').css('display', 'block');
            $('#iFilterPeriod').css('display', 'none');
            break;
          case 'Stats_by_ip':
          case 'Stats_by_category':
          case 'Stats_by_image':
            // display filter block
            $('#iTabFilter').css('display', 'block');
            $('#iFilterCategory').css('display', 'block');
            $('#iFilterPeriod').css('display', 'block');
            break;
          //case 'Synthesis':
          case 'History':
          //case 'Config':
          //case 'Tools':
            // hide filter block
            $('#iTabFilter').css('display', 'none');
            $('#iFilterCategory').css('display', 'none');
            $('#iFilterPeriod').css('display', 'none');
            break;
          default:
            return(false);
        }
        properties.currentPage=pageName;
        return(loadPage(properties.currentPage));
      }, // << changePage


    /**
     * -----------------------------------------------------------------------
     * this function manage the page content's loading
     *
     * @param String pageName : the name of page which content have to be loaded
     * @return Boolean : true if ok, otherwise false
     * -----------------------------------------------------------------------
     */
    loadPage = function(pageName)
      {
        setProperties();
        displayPopupInfo(false);
        displayPopupThumb(false);

        if(pageName==null)
        {
          pageName=properties.currentPage;
        }
        else
        {
          setProperties({currentPage:pageName});
        }

        switch(pageName)
        {
          case 'Stats_by_period':
            loadPageStatByPeriod();
            break;
          case 'Stats_by_ip':
            loadPageStatByIp();
            break;
          case 'Stats_by_category':
            loadPageStatByCategory();
            break;
          case 'Stats_by_image':
            loadPageStatByImage();
            break;
          case 'Synthesis':
            loadPageSynthesis();
            break;
          case 'History':
            loadPageHistory();
            break;
          case 'Config':
            loadPageConfig();
            break;
          case 'Tools':
            loadPageTools();
            break;
          default:
            return(false);
        }
        return(true);
      }, // << loadPage()



    /**
     * -----------------------------------------------------------------------
     * load content for the "Period" page
     *
     *  - period table
     *  - period graph
     * -----------------------------------------------------------------------
     */
    loadPageStatByPeriod = function ()
      {
        $('#iPeriodTable').dynamicTable('resizeContent');
        $('#iPeriodGraph').drawingGraph('options',
                            {
                              display:{
                                  width:$('#iPeriodTable').width(),
                                  height:$('#iPeriodTable').height()
                                }
                            }
                          );

        refreshGraphPeriod();
        refreshPagePeriodContent();
      }, // << loadPageStatByPeriod()

    loadPageStatByIp = function ()
      {
        var width=$('#iTabStats_by_ip').width()*0.29,
            height=$('#iIPTable').height(),
            radius=Math.min(width, height)*0.35;

        properties.ip.graphType.serie.get().options.set({outerRadius:radius});
        properties.ip.graphCountry.serie.get().options.set({outerRadius:radius});

        $('#iIPTable').dynamicTable('resizeContent');
        $('#iIPGraphType').drawingGraph('options',
                            {
                              display:{
                                  width:width,
                                  height:height
                                }
                            }
                          );
        $('#iIPGraphCountry').drawingGraph('options',
                            {
                              display:{
                                  width:width,
                                  height:height
                                }
                            }
                          );
        refreshGraphIP();
        refreshPageIPContent();
      }, // << loadPageStatByIp()

    loadPageStatByCategory = function ()
      {
        $('#iCategoryTable').dynamicTable('resizeContent');
        refreshPageCategoryContent();
      }, // << loadPageStatByCategory()

    loadPageStatByImage = function ()
      {
        $('#iImageTable').dynamicTable('resizeContent');
        refreshPageImageContent();
      }, // << loadPageStatByImage()

    loadPageSynthesis = function ()
      {
      }, // << loadPageSynthesis()


    /**
     * -----------------------------------------------------------------------
     * load content for the "History" page
     *
     *  - history table
     *  - history graph
     * -----------------------------------------------------------------------
     */
    loadPageHistory = function (period)
      {
        $('#iHistoryTable').dynamicTable('resizeContent');
        refreshGraphHistoryMonth(period);
        refreshPageHistoryContent(period, 1);
      }, // << loadPageHistory()

    loadPageConfig = function ()
      {
      }, // << loadPageConfig()

    loadPageTools = function ()
      {
      }, // << loadPageTools()



    /**
     * -----------------------------------------------------------------------
     * load the content of period table
     *
     * @param integer period: period the load; if not set, load the current period
     * -----------------------------------------------------------------------
     */
    refreshPagePeriodContent = function (period)
      {
        if(period==null)
          period=$('#iPeriodPath').inputPath('itemLevel', $('#iPeriodPath').inputPath('level')).id;

        // load the table content
        $('#iPeriodTable')
          .dynamicTable('postData',
              {
                ajaxfct:'admin.stat.period',
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              }
            )
          .dynamicTable('refreshContent', 1);

      }, // << refreshPagePeriodContent()



    /**
     * -----------------------------------------------------------------------
     * load graph data for a period
     *
     * @param String period: the period (YYYYMM) to load; if not set, load the current period
     * -----------------------------------------------------------------------
     */
    refreshGraphPeriod = function (period)
      {
        if(period==null)
          period=$('#iPeriodPath').inputPath('itemLevel', $('#iPeriodPath').inputPath('level')).id;

        $.ajax(
          {
            type: "POST",
            url: properties.url,
            data:
              {
                ajaxfct:'admin.stat.period.graph',
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              },
            async: true,
            success: function(msg)
              {
                msg=$.parseJSON(msg);
                properties.period.graph.axis.set(
                  {
                    XY:{ticks:{V:{steps:roundValue(msg.maxValue)}}}
                  }
                );
                properties.period.graph.axis.set(
                  {
                    XY:{ticks:{V:{frequency:calculateTicks(properties.period.graph.axis)}}}
                  }
                );
                properties.period.graph.axis.setValues({H:msg.axis});
                properties.period.graph.serieViewedAlbums.set(
                  {
                    values:msg.series.viewedAlbums.nbVisits,
                    name:msg.series.viewedAlbums.name
                  }
                );
                properties.period.graph.serieViewedImages.set(
                  {
                    values:msg.series.viewedImages.nbVisits,
                    name:msg.series.viewedImages.name
                  }
                );
                properties.period.graph.serieViewedPages.set(
                  {
                    values:msg.series.viewedPages.nbVisits,
                    name:msg.series.viewedPages.name
                  }
                );
                properties.period.graph.serieUniqueIP.set(
                  {
                    values:msg.series.uniqueIP.nbVisits,
                    name:msg.series.uniqueIP.name
                  }
                );
                $('#iPeriodGraph').drawingGraph('refresh');
              },
            error: function(msg)
              {
              }
          }
        );
      }, // << refreshGraphPeriod()





    /**
     * -----------------------------------------------------------------------
     * load the content of history table
     *
     * @param integer period: period the load; if not set, load the current period
     * @param integer pageNumber: page to load
     * -----------------------------------------------------------------------
     */
    refreshPageHistoryContent = function (period, pageNumber)
      {
        if(period==null) period=$('#iHistoryFilterPeriod').inputList('value');

        if(pageNumber==null | pageNumber<=0) pageNumber=1;

        // load the table content
        $('#iHistoryTable')
          .dynamicTable('postData',
              {
                ajaxfct:'admin.stat.history',
                token:properties.token,
                period:period
              }
            )
          .dynamicTable('refreshContent', pageNumber);
      }, // << refreshPageHistoryContent()

    /**
     * -----------------------------------------------------------------------
     * load graph data for a period
     *
     * @param String priod: the period (YYYYMM) to load; if not set, load the current period
     * -----------------------------------------------------------------------
     */
    refreshGraphHistoryMonth = function (period)
      {
        if(period==null) period=$('#iHistoryFilterPeriod').inputList('value');

        $.ajax(
          {
            type: "POST",
            url: properties.url,
            data:
              {
                ajaxfct:'admin.stat.history.graphAllPeriods',
                token:properties.token,
                period:period,
                nbMonth:12
              },
            async: true,
            success: function(msg)
              {
                msg=$.parseJSON(msg);
                properties.history.graphAllPeriods.axis.set(
                  {
                    XY:{ticks:{V:{steps:roundValue(msg.maxValue)}}}
                  }
                );
                properties.history.graphAllPeriods.axis.set(
                  {
                    XY:{ticks:{V:{frequency:calculateTicks(properties.history.graphAllPeriods.axis)}}}
                  }
                );
                properties.history.graphAllPeriods.axis.setValues({H:msg.axis});
                properties.history.graphAllPeriods.serieTotal.set(
                  {
                    values:msg.series.total.nbVisits,
                    name:msg.series.total.name
                  }
                );
                properties.history.graphAllPeriods.serieComputer.set(
                  {
                    values:msg.series.computer.nbVisits,
                    name:msg.series.computer.name
                  }
                );
                properties.history.graphAllPeriods.serieCrawler.set(
                  {
                    values:msg.series.crawler.nbVisits,
                    name:msg.series.crawler.name
                  }
                );
                properties.history.graphAllPeriods.serieMobile.set(
                  {
                    values:msg.series.mobile.nbVisits,
                    name:msg.series.mobile.name
                  }
                );
                properties.history.graphAllPeriods.serieOther.set(
                  {
                    values:msg.series.other.nbVisits,
                    name:msg.series.other.name
                  }
                );
                $('#iHistoryGraphAll').drawingGraph('refresh');
              },
            error: function(msg)
              {
              }
          }
        );

        $.ajax(
          {
            type: "POST",
            url: properties.url,
            data:
              {
                ajaxfct:'admin.stat.history.graphCurrentPeriod',
                token:properties.token,
                period:period
              },
            async: true,
            success: function(msg)
              {
                msg=$.parseJSON(msg);
                properties.history.graphCurrentPeriod.axis.set(
                  {
                    XY:{ticks:{V:{steps:roundValue(msg.maxValue)}}}
                  }
                );
                properties.history.graphCurrentPeriod.axis.set(
                  {
                    XY:{ticks:{V:{frequency:calculateTicks(properties.history.graphCurrentPeriod.axis)}}}
                  }
                );
                properties.history.graphCurrentPeriod.axis.setValues({H:msg.axis});
                properties.history.graphCurrentPeriod.serieTotal.set(
                  {
                    values:msg.series.total.nbVisits,
                    name:msg.series.total.name
                  }
                );
                properties.history.graphCurrentPeriod.serieComputer.set(
                  {
                    values:msg.series.computer.nbVisits,
                    name:msg.series.computer.name
                  }
                );
                properties.history.graphCurrentPeriod.serieCrawler.set(
                  {
                    values:msg.series.crawler.nbVisits,
                    name:msg.series.crawler.name
                  }
                );
                properties.history.graphCurrentPeriod.serieMobile.set(
                  {
                    values:msg.series.mobile.nbVisits,
                    name:msg.series.mobile.name
                  }
                );
                properties.history.graphCurrentPeriod.serieOther.set(
                  {
                    values:msg.series.other.nbVisits,
                    name:msg.series.other.name
                  }
                );
                $('#iHistoryGraphCurrent').drawingGraph('refresh');
              },
            error: function(msg)
              {
              }
          }
        );
      }, // << refreshGraphHistoryMonth()




    /**
     * -----------------------------------------------------------------------
     * load the content of IP table
     *
     * @param integer period: period the load; if not set, load the current period
     *                          A           : all periods
     *                          Y-yyyy      : year
     *                          YM-yyyymm   : year/month
     * -----------------------------------------------------------------------
     */
    refreshPageIPContent = function (period)
      {
        if(period==null)
          period=$('#iFilterPeriodId').inputTreeList('value');

        // load the table content
        $('#iIPTable')
          .dynamicTable('postData',
              {
                ajaxfct:"admin.stat.ip",
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              }
            )
          .dynamicTable('refreshContent', 1);
      }, // << refreshPagePeriodContent()



    /**
     * -----------------------------------------------------------------------
     * load graph data for IP
     *
     * @param integer period: period the load; if not set, load the current period
     *                          A           : all periods
     *                          Y-yyyy      : year
     *                          YM-yyyymm   : year/month
     * -----------------------------------------------------------------------
     */
    refreshGraphIP = function (period)
      {
        if(period==null)
          period=$('#iFilterPeriodId').inputTreeList('value');

        $.ajax(
          {
            type: "POST",
            url: properties.url,
            data:
              {
                ajaxfct:"admin.stat.ip.graphType",
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              },
            async: true,
            success: function(msg)
              {
                msg=$.parseJSON(msg);

                properties.ip.graphType.serie.set(
                  {
                    values:msg.values,
                    valuesLabels:msg.valuesLabels
                  }
                );

                $('#iIPGraphType').drawingGraph('refresh');
              },
            error: function(msg)
              {
              }
          }
        );

        $.ajax(
          {
            type: "POST",
            url: properties.url,
            data:
              {
                ajaxfct:"admin.stat.ip.graphCountry",
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              },
            async: true,
            success: function(msg)
              {
                msg=$.parseJSON(msg);

                properties.ip.graphCountry.serie.set(
                  {
                    values:msg.values,
                    valuesLabels:msg.valuesLabels
                  }
                );

                $('#iIPGraphCountry').drawingGraph('refresh');
              },
            error: function(msg)
              {
              }
          }
        );

      }, // << refreshGraphIP()




    /**
     * -----------------------------------------------------------------------
     * load the content of album/categories table
     *
     * @param integer period: period the load; if not set, load the current period
     * -----------------------------------------------------------------------
     */
    refreshPageCategoryContent = function (period)
      {
        if(period==null)
          period=$('#iFilterPeriodId').inputTreeList('value');

        // load the table content
        $('#iCategoryTable')
          .dynamicTable('postData',
              {
                ajaxfct:"admin.stat.category",
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              }
            )
          .dynamicTable('refreshContent', 1);
      }, // << refreshPageCategoryContent()





    /**
     * -----------------------------------------------------------------------
     * load the content of images table
     *
     * @param integer period: period the load; if not set, load the current period
     * -----------------------------------------------------------------------
     */
    refreshPageImageContent = function (period)
      {
        if(period==null)
          period=$('#iFilterPeriodId').inputTreeList('value');

        // load the table content
        $('#iImageTable')
          .dynamicTable('postData',
              {
                ajaxfct:"admin.stat.image",
                token:properties.token,
                period:period,
                additionalFilter:{catId:$('#iFilterCatId').categorySelector('value')}
              }
            )
          .dynamicTable('refreshContent', 1);
      }, // << refreshPageCategoryContent()




    /**
     * -------------------------------------------------------------------------
     *
     *                      UTILITIES FUNCTIONS
     *
     *
     * -------------------------------------------------------------------------
     */

    /**
      * -----------------------------------------------------------------------
      * generic function used to round a value to nearest number according to
      * to 'size' of the value
      *
      * example:
      *   157   => 160
      *   241   => 250
      *   1247  => 1250
      *   12478 => 12500
      *
      * @param Integer value: the value to be rounded
      * @return Integer: rounded value
      * -----------------------------------------------------------------------
      */
    roundValue = function (value)
      {
        var divider=1;

        if(value<=1000)
        {
          divider=10;
        }
        else if(value<10000)
        {
          divider=100;
        }
        else
        {
          divider=1000;
        }
        return(Math.ceil(value/divider)*divider);
      },

    /**
     * -----------------------------------------------------------------------
     * calculate ticks values according to the current axis properties
     * (height in pixel and max value)
     *
     * @param CDAxis axis: axis
     * @return object: {small:(Integer), big:(Integer)}
     * -----------------------------------------------------------------------
     */
    calculateTicks = function (axis)
      {
        var divider=1,
            maxValue=axis.get().properties.XY.ticks.V.steps,
            returned={
              small:0,
              big:0
            };

        if(maxValue<=10)
        {
          divider=1;
        }
        else if(maxValue<=100)
        {
          divider=10;
        }
        else if(maxValue<=1000)
        {
          divider=100;
        }
        else if(maxValue<10000)
        {
          divider=1000;
        }
        else
        {
          divider=10000;
        }
        returned.small=Math.ceil(maxValue/divider)*divider/20;
        returned.big=5*returned.small;
        return(returned);
      },

    /**
     * -----------------------------------------------------------------------
     * display the popup info box
     *
     * @param Boolean visible: display or hide the popup
     * @param object geometry: {x:(Integer), y:(Integer), w:(Integer), h:(Integer)} object to set the position
     * @param String content: content of the box
     * -----------------------------------------------------------------------
     */
    displayPopupInfo = function (visible, geometry, content)
      {
        if(content==null) content='';
        if(geometry==null) geometry={x:-1, y:-1, w:0, h:0};
        if(visible==null) visible=false;

        $('#iPopupInfo')
          .html(content)
          .css(
            {
              'left':geometry.x+'px',
              'top':geometry.y+'px',
              'width':geometry.w+'px',
              'height':geometry.h+'px',
              'display':visible?'block':'none'
            }
          );
      },

    /**
     * -----------------------------------------------------------------------
     * display the popup thumbnail image
     *
     * @param Boolean visible: display or hide the popup
     * @param object geometry: {x:(Integer), y:(Integer)} object to set the position
     * @param String url: url of the thumbnail
     * -----------------------------------------------------------------------
     */
    displayPopupThumb = function (visible, geometry, url)
      {
        if(geometry==null) geometry={x:-1, y:-1};
        if(visible==null) visible=false;
        if(url==null)
        {
          visible=false;
          url='';
        }
        if(visible)
        {
          $('#iPopupThumb')
            .unbind('load')
            .bind('load', {geometry:geometry}, function (e)
                    {
                      $(this).css(
                        {
                          'left':(e.data.geometry.x-e.target.width/2)+'px',
                          'top':(e.data.geometry.y-e.target.height-15)+'px',
                          'display':'block'
                        }
                      );
                    }
                  )
            .attr('src', url);
        }
        else
        {
          $('#iPopupThumb').unbind('load').css('display', 'none');
        }
      },

    /**
     * -----------------------------------------------------------------------
     * return the html content for popup box on history graph
     * -----------------------------------------------------------------------
     */
    getHistoryPopupContent = function ()
      {
        return(
          "<span class='nfoC'>"+translateString.events+"</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[0]+"'>"+translateString.ua_Computer+"</span>"+
          "<span class='nfoR' id='iPI_computer'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[1]+"'>"+translateString.ua_Mobile+"</span>"+
          "<span class='nfoR' id='iPI_mobile'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[2]+"'>"+translateString.ua_Crawler+"</span>"+
          "<span class='nfoR' id='iPI_crawler'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[3]+"'>"+translateString.ua_Other+"</span>"+
          "<span class='nfoR' id='iPI_other'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.gray[3]+"'>"+translateString.total+"</span>"+
          "<span class='nfoR' id='iPI_total'>-</span>"
        );
      },

    /**
     * -----------------------------------------------------------------------
     * return the html content for popup box on period graph
     * -----------------------------------------------------------------------
     */
    getPeriodPopupContent = function ()
      {
        return(
          "<span class='nfoC'>"+translateString.visits+"</span><br>"+
          "<span style='color:"+properties.graph.colors.gray[3]+"'>"+translateString.viewedPages+"</span>"+
          "<span class='nfoR' id='iPI_viewedPages'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[0]+"'>"+translateString.viewedAlbums+"</span>"+
          "<span class='nfoR' id='iPI_viewedAlbums'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[1]+"'>"+translateString.viewedImages+"</span>"+
          "<span class='nfoR' id='iPI_viewedImages'>-</span><br>"+
          "<span style='color:"+properties.graph.colors.normal[2]+"'>"+translateString.uniqueIP+"</span>"+
          "<span class='nfoR' id='iPI_uniqueIP'>-</span><br>"
        );
      }


    /**
     * -----------------------------------------------------------------------
     * action done when user click on the period table
     *
     * this function is set has an event on $('#iPeriodTable') object
     * -----------------------------------------------------------------------
     */
    clickOnPeriodTable = function (event)
      {
        var oId=$(this).attr('oId'),
            data=$('#iPeriodTable').dynamicTable('loadedData', oId),
            period='';

        switch($('#iPeriodPath').inputPath('level'))
        {
          case 1:
            // all years => years
            $('#iPeriodPath').inputPath('push', {id:'y-'+data[5], label:data[0]} );
            break;
          case 2:
            // year => months
            period=$('#iPeriodPath').inputPath('itemLevel', $('#iPeriodPath').inputPath('level')).id.substr(2);
            $('#iPeriodPath').inputPath('push', {id:'ym-'+period+data[5], label:data[0]} );
            break;
          case 3:
            // month => days
            break;
        }
        refreshGraphPeriod();
        refreshPagePeriodContent();
      };

/**
  * ----------------------------------------------------------------------------
  *
  *                             MAIN OBJECT FUNCTION
  *
  *
  * ----------------------------------------------------------------------------
  */


  switch(fct)
  {
    case 'init':
      setProperties(values);
      init();
      break;
    case 'changePage':
      setProperties(null);
      changePage(values);
      break;
  }
}
